---
"@context": https://schema.org
"@type": TechArticle
"@id": https://www.twilio.com/docs/sendgrid/api-reference/how-to-use-the-sendgrid-v3-api/rate-limits#article
headline: Rate Limits
description: Explore SendGrid's Web API v3 features with this comprehensive guide. Understand rate limits, status codes, and more for efficient API calls.
url: https://www.twilio.com/docs/sendgrid/api-reference/how-to-use-the-sendgrid-v3-api/rate-limits
inLanguage: en
dateModified: 2026-07-02T17:35:39.000Z
author:
  "@type": Organization
  name: Twilio Developer Education Team
publisher:
  "@type": Organization
  name: Twilio
---

# Rate Limits

## Twilio supported SDKs

The Twilio SendGrid Web REST API v3 provides SDKs for seven different languages.

* [C#](https://github.com/sendgrid/sendgrid-csharp)
* [Go](https://github.com/sendgrid/sendgrid-go)
* [Java](https://github.com/sendgrid/sendgrid-java)
* [Node.js](https://github.com/sendgrid/sendgrid-nodejs)
* [PHP](https://github.com/sendgrid/sendgrid-php)
* [Python](https://github.com/sendgrid/sendgrid-python)
* [Ruby](https://github.com/sendgrid/sendgrid-ruby)

## Rate limit response headers

Each Web API response includes rate-limit headers that indicate how many requests remain in the current refresh period. Each endpoint permits a fixed number of requests per refresh period. If you exceed that limit, the API returns an HTTP `429` (Too Many Requests) status code.

### Example

```text
GET https://api.sendgrid.com/v3/resource HTTP/1.1
```

```text
HTTP/1.1 200 OK
Content-Type: application/json
X-RateLimit-Limit: 500
X-RateLimit-Remaining: 499
X-RateLimit-Reset: 1392815263

{
  "foo": "bar"
}
```

## When You Reach a Rate Limit

When you reach a rate limit, you can no longer make requests against that endpoint for the remainder of the refresh period, and the API returns a `429` response.

### Example \[#example-2]

```text
GET https://api.sendgrid.com/v3/resource/ HTTP/1.1
```

```text
HTTP/1.1 429 TOO MANY REQUESTS
Content-Type: application/json
X-RateLimit-Limit: 150
X-RateLimit-Remaining: 0
X-RateLimit-Reset: 1392815263

{
  "errors": [
    {
      "field": null,
       "message": "too many requests"
    },
  ]
}
```
